## milkytracker 1.06+dfsg

=== CMakeLists.txt ===
#
#  CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.10)
project(MilkyTracker)

# Set C++ standard to C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)

# Enable IDE solution folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Enable tracker-specific functions in MilkyPlay
add_definitions(-DMILKYTRACKER)

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

# Force SDL if requested
option(FORCESDL "Force SDL instead of native" OFF)
if(FORCESDL)
    unset(APPLE)
    unset(WIN32)
    add_definitions(-D__FORCE_SDL_AUDIO__)
endif()

# Lowercase project name for binaries and packaging
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string(TOLOWER ${CMAKE_SYSTEM_NAME} SYSTEM_NAME_LOWER)

# Additional CMake modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Version number in format X.YY.ZZ
set(VER_X  1)
set(VER_YY 05)
set(VER_ZZ 01)
set(VER_FULL "${VER_X}.${VER_YY}.${VER_ZZ}")

# Generate version header from the above
configure_file(
    ${PROJECT_SOURCE_DIR}/src/tracker/version.h.in
    ${PROJECT_BINARY_DIR}/src/tracker/version.h
)

# Packaging
option(BUILD_DMG "Build DMG package on macOS" ON)

if(APPLE AND BUILD_DMG)
    set(CPACK_GENERATOR DragNDrop)
    set(CPACK_DMG_VOLUME_NAME "${PROJECT_NAME} ${VER_FULL}")
    set(
        CPACK_DMG_DS_STORE_SETUP_SCRIPT
        ${PROJECT_SOURCE_DIR}/resources/packaging/osx/DMGSetup.scpt
    )
    set(
        CPACK_DMG_BACKGROUND_IMAGE
        ${PROJECT_SOURCE_DIR}/resources/packaging/osx/DMGBackground.tif
    )
elseif(WIN32)
    set(CPACK_GENERATOR ZIP)
else()
    set(CPACK_GENERATOR TGZ)
endif()
set(CPACK_PACKAGE_NAME ${PROJECT_NAME_LOWER})
set(CPACK_PACKAGE_VENDOR "MilkyTracker Team")
set(CPACK_PACKAGE_CONTACT "support@milkytracker.org")
set(CPACK_PACKAGE_VERSION_MAJOR ${VER_X})
set(CPACK_PACKAGE_VERSION_MINOR ${VER_YY})
set(CPACK_PACKAGE_VERSION_PATCH ${VER_ZZ})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "FastTracker II compatible music tracker")
include(CPack)

if(APPLE)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")

    # Set variables for generating the Info.plist file
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${VER_FULL}")
    set(MACOSX_BUNDLE_EXECUTABLE ${PROJECT_NAME})
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "com.Titan.MilkyTracker")
    set(MACOSX_BUNDLE_NSMAIN_NIB_FILE "Application")
    set(MACOSX_BUNDLE_ICON_FILE "carton")
    set(MACOSX_BUNDLE_NAME ${PROJECT_NAME})
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VER_FULL}")

    # Carbon only required for HIToolbox/Events.h (virtual keycodes)
    find_library(CARBON_LIBRARY Carbon)
    find_library(COCOA_LIBRARY Cocoa)
    find_library(CORE_AUDIO_LIBRARY CoreAudio)
    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
    find_library(CORE_MIDI_LIBRARY CoreMIDI)
    find_library(CORE_VIDEO_LIBRARY CoreVideo)
    find_library(OPENGL_LIBRARY OpenGL)

    # OS X MIDI support requires no external libraries
    message(STATUS "Enabled MIDI support (Core MIDI)")
    add_subdirectory(src/midi)
elseif(WIN32)
    # Visual C++ Compiler options
    if(MSVC)
        # Warn if platform toolset may not be targetting Windows XP upwards
        if(NOT CMAKE_VS_PLATFORM_TOOLSET MATCHES "xp")
            message(WARNING
                "Your currently-selected platform toolset may generate "
                "executables which are incompatible with Windows XP.\n"
                "Please set your toolset to be one of v110_xp, v120_xp or "
                "v140_xp for VS2012, VS2013, and VS2015 respectively.\n"
                "You can do so with the '-T' argument to CMake, or by entering "
                "it in the CMake GUI."
            )
        endif()

        # Suppress secure string function warnings
        add_definitions(-D_CRT_SECURE_NO_WARNINGS)

        # Enable parallel compilation
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

        # Enable static linkage of the Microsoft Visual C/C++ Runtime
        set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MTd")
        set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MT")
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set(
            CMAKE_CXX_FLAGS_RELWITHDEBINFO
            "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MTd"
        )
        set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MT")
    endif()

    # Prevent Windows.h from clashing with the Standard Template Library so we
    # can use std::min/std::max (see https://support.microsoft.com/kb/143208)
    add_definitions(-DNOMINMAX)

    # Windows MIDI support requires no external libraries
    message(STATUS "Enabled MIDI support (WinMM)")
    add_subdirectory(src/midi)
elseif(HAIKU)
    # Haiku MIDI support requires no external libraries
    message(STATUS "Enabled MIDI support (Haiku)")
    add_subdirectory(src/midi)
else()
    # Workaround for SDL bug #3295, which occurs in SDL2 <2.0.5
    # https://bugzilla.libsdl.org/show_bug.cgi?id=3295
    cmake_policy(SET CMP0004 OLD)

    find_package(SDL2 REQUIRED)
endif()

# Prefer static linkage under OS X for libraries located with find_package()
if(APPLE)
    set(SUFFIXES_ORIG ${CMAKE_FIND_LIBRARY_SUFFIXES})
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

# Under macOS and Windows we use Git Submodules to locate the decompression libs
if(UNIX)
    # zlib is provided by Linux and macOS
    find_package(ZLIB)

    # We can't use Brew for these due to OSX target version mismatch
    # (we're targeting an older version of OSX to increase compatibility)
    if(NOT APPLE)
      find_package(LHASA)
      find_package(ZZIPLIB)
    endif()

    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        find_package(ALSA)
        find_package(JACK)

        # Linux MIDI support requires ALSA and RtMidi
        if(ALSA_FOUND)
            find_package(RTMIDI 2.1)              # 2.1.0 and compatible versions
            if(RTMIDI_FOUND)                      # https://github.com/milkytracker/MilkyTracker/issues/309
                set(CMAKE_CXX_STANDARD 11)        # https://github.com/milkytracker/MilkyTracker/issues/262  
                message(STATUS "Enabled MIDI support (ALSA/RtMidi)")
                add_subdirectory(src/midi)
            else()
                message("MIDI support disabled (RtMidi unavailable)")
            endif()
        else()
            message("MIDI support disabled (ALSA unavailable)")
        endif()

        # Metainfo version and timestamp configuration, mandatory for flathub
        string( TIMESTAMP METAINFO_DATE "%Y-%m-%d" )
        configure_file(
            ${PROJECT_SOURCE_DIR}/resources/org.milkytracker.MilkyTracker.metainfo.xml.in
            ${PROJECT_BINARY_DIR}/resources/org.milkytracker.MilkyTracker.metainfo.xml
            @ONLY
        )
    endif()
endif()

# Restore library suffixes
if(APPLE)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ${SUFFIXES_ORIG})
endif()

add_subdirectory(docs)
add_subdirectory(resources/music)
add_subdirectory(src/compression)
add_subdirectory(src/fx)
add_subdirectory(src/milkyplay)
add_subdirectory(src/ppui)
add_subdirectory(src/tracker)
add_subdirectory(src/tools/milkycli)

# Set MilkyTracker target as startup project in Visual Studio
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT tracker)

=== docs/CMakeLists.txt ===
#
#  docs/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(
    DOCUMENTS
    ChangeLog.html
    FAQ.html
    MilkyTracker.html
    TiTAN.nfo
    ChangeLog.html
)

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
    set(BSD TRUE)
endif()

if(APPLE)
    set(INSTALL_DEST Documentation)
elseif(BSD)
    set(INSTALL_DEST share/doc/${PROJECT_NAME_LOWER})
elseif(WIN32)
    list(APPEND DOCUMENTS readme_rtaudio)
    set(INSTALL_DEST .)
else()
    list(APPEND DOCUMENTS readme_unix)
    set(INSTALL_DEST ${CMAKE_INSTALL_DOCDIR})
endif()

install(FILES ${DOCUMENTS} DESTINATION ${INSTALL_DEST})
install(FILES ../AUTHORS DESTINATION ${INSTALL_DEST} RENAME Authors.txt)
install(FILES ../COPYING DESTINATION ${INSTALL_DEST} RENAME Copying.txt)
# add_custom_command(OUTPUT ChangeLog.html COMMAND pandoc ARGS "-so ChangeLog.html ../ChangeLog.md")

=== src/fx/CMakeLists.txt ===
#
#  src/fx/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

add_library(fx STATIC
    # Sources
    Camera.cpp
    Filter.cpp
    Fire.cpp
    Math3d.cpp
    ParticleBlobs.cpp
    ParticleEmitter.cpp
    ParticleFX.cpp
    ParticleFun.cpp
    ParticleScene.cpp
    Starfield.cpp
    TCBSpline.cpp
    TCBSplineTest.cpp
    Texture.cpp
    TexturedGrid.cpp
    TexturedPlane.cpp
    Twister.cpp
    TwisterFX.cpp
    fpmath.cpp

    # Headers
    Camera.h
    FXAbstract.h
    FXInterface.h
    Filter.h
    Fire.h
    Math3d.h
    ParticleBlobs.h
    ParticleEmitter.h
    ParticleFX.h
    ParticleFun.h
    ParticleScene.h
    PictureGlow.h
    Starfield.h
    TCBSpline.h
    TCBSplineTest.h
    Texture.h
    TexturedGrid.h
    TexturedPlane.h
    Twister.h
    TwisterFX.h
    fpmath.h
)

target_include_directories(fx
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface/posix
        ${CMAKE_CURRENT_SOURCE_DIR}/../ppui
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)

=== src/midi/CMakeLists.txt ===
#
#  src/midi/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

add_library(midi STATIC
    # Headers
    MidiTools.h
)

target_include_directories(midi
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../milkyplay
        ${CMAKE_CURRENT_SOURCE_DIR}/../ppui
        ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface
        ${CMAKE_CURRENT_SOURCE_DIR}/../tracker
)

# Add platform-specific sources and include paths
if(APPLE)
    target_sources(midi PRIVATE
        # Sources
        osx/MidiReceiver_CoreMIDI.mm

        # Headers
        osx/MidiReceiver_CoreMIDI.h
    )

    # Enable ARC (automatic reference counting) for OS X build
    target_compile_options(midi PRIVATE -fobjc-arc)

    target_include_directories(midi
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/osx
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface/posix
    )

    target_link_libraries(midi PUBLIC ${CORE_MIDI_LIBRARY})
elseif(WIN32)
    target_sources(midi PRIVATE
        # Sources
        win32/LongMsg.cpp
        win32/MidiInDevice.cpp
        win32/MidiReceiver_win32.cpp
        win32/ShortMsg.cpp

        # Headers
        win32/LongMsg.h
        win32/MIDIInDevice.h
        win32/MIDIMsg.h
        win32/MidiReceiver_win32.h
        win32/ShortMsg.h
        win32/midi.h
    )

    target_include_directories(midi
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/win32
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface/win32
    )

    target_link_libraries(midi PUBLIC winmm)
elseif(HAIKU)
    target_sources(midi PRIVATE
        # Sources
        haiku/MidiSetup.cpp
        haiku/MilkyMidiConsumer.cpp

        # Headers
        haiku/MidiSetup.h
        haiku/MilkyMidiConsumer.h
    )

    target_include_directories(midi
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/haiku
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface/posix
    )

    target_link_libraries(midi PUBLIC midi2)
else()
    target_sources(midi PRIVATE
        # Sources
        posix/MidiReceiver_pthread.cpp

        # Headers
        posix/MidiReceiver_pthread.h
    )

    target_include_directories(midi
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/../ppui/osinterface/posix
            ${RTMIDI_INCLUDE_DIRS}
    )

    target_link_libraries(midi PUBLIC ${RTMIDI_LIBRARIES})
endif()

=== src/milkyplay/CMakeLists.txt ===
#
#  src/milkyplay/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

add_library(milkyplay STATIC
    # Sources
    AudioDriverBase.cpp
    AudioDriverManager.cpp
    AudioDriver_NULL.cpp
    AudioDriver_WAVWriter.cpp
    ChannelMixer.cpp
    ExporterXM.cpp
    LittleEndian.cpp
    Loader669.cpp
    LoaderAMF.cpp
    LoaderAMS.cpp
    LoaderCBA.cpp
    LoaderDBM.cpp
    LoaderDIGI.cpp
    LoaderDSM.cpp
    LoaderDTM.cpp
    LoaderFAR.cpp
    LoaderGDM.cpp
    LoaderIMF.cpp
    LoaderIT.cpp
    LoaderMDL.cpp
    LoaderMOD.cpp
    LoaderMTM.cpp
    LoaderMXM.cpp
    LoaderOKT.cpp
    LoaderPLM.cpp
    LoaderPSM.cpp
    LoaderPTM.cpp
    LoaderS3M.cpp
    LoaderSTM.cpp
    LoaderULT.cpp
    LoaderUNI.cpp
    LoaderXM.cpp
    MasterMixer.cpp
    PlayerBase.cpp
    PlayerFAR.cpp
    PlayerGeneric.cpp
    PlayerIT.cpp
    PlayerSTD.cpp
    ResamplerFactory.cpp
    SampleLoaderAIFF.cpp
    SampleLoaderALL.cpp
    SampleLoaderAbstract.cpp
    SampleLoaderGeneric.cpp
    SampleLoaderIFF.cpp
    SampleLoaderWAV.cpp
	SampleLoaderSF2.cpp
    XIInstrument.cpp
    XMFile.cpp
    XModule.cpp

    # Headers
    AudioDriverBase.h
    AudioDriverManager.h
    AudioDriver_COMPENSATE.h
    AudioDriver_NULL.h
    AudioDriver_WAVWriter.h
    ChannelMixer.h
    LittleEndian.h
    Loaders.h
    MasterMixer.h
    MilkyPlay.h
    MilkyPlayCommon.h
    MilkyPlayResults.h
    MilkyPlayTypes.h
    Mixable.h
    PlayerBase.h
    PlayerFAR.h
    PlayerGeneric.h
    PlayerIT.h
    PlayerSTD.h
    ResamplerAmiga.h
    ResamplerCubic.h
    ResamplerFactory.h
    ResamplerFast.h
    ResamplerMacros.h
    ResamplerSinc.h
    SampleLoaderAIFF.h
    SampleLoaderALL.h
    SampleLoaderAbstract.h
    SampleLoaderGeneric.h
    SampleLoaderIFF.h
    SampleLoaderWAV.h
    XIInstrument.h
    XMFile.h
    XModule.h
    computed-blep.h
)

target_include_directories(milkyplay
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
    PRIVATE
        # Include the CMake-generated version header from the build directory
        # (version string required when saving modules)
        ${PROJECT_BINARY_DIR}/src/tracker
)

# Add platform-specific sources, include paths, definitions and link libraries
if(APPLE)
    target_sources(milkyplay
        PRIVATE
            # Sources
            drivers/osx/AudioDriver_COREAUDIO.mm

            # Headers
            drivers/osx/AudioDriver_COREAUDIO.h
    )
    target_include_directories(milkyplay
        PRIVATE
            drivers/osx
    )
    target_link_libraries(milkyplay
        PRIVATE
            ${COCOA_LIBRARY}
            ${CORE_AUDIO_LIBRARY}
            ${CORE_FOUNDATION_LIBRARY}
    )
    message(STATUS "Enabled Core Audio support")
elseif(WIN32)
    # Basic WaveOut support
    target_sources(milkyplay
        PRIVATE
            # Sources
            drivers/windows/AudioDriver_MMSYSTEM.cpp

            # Headers
            drivers/windows/AudioDriver_MMSYSTEM.h
    )

    target_include_directories(milkyplay
        PRIVATE
            drivers/windows
    )

    message(STATUS "Enabled WaveOut support")

    # Build sources from RtAudio Git submodule if present
    set(RTAUDIO_SUBMODULE_DIR ${PROJECT_SOURCE_DIR}/src/submodules/rtaudio)
    if(EXISTS ${RTAUDIO_SUBMODULE_DIR}/CMakeLists.txt)
        message(STATUS "Enabled RtAudio support")

        set(RTAUDIO_BUILD_SHARED_LIBS OFF)
        set(RTAUDIO_BUILD_TESTING OFF)
        add_subdirectory(${RTAUDIO_SUBMODULE_DIR} ${CMAKE_BINARY_DIR}/src/submodules/rtaudio EXCLUDE_FROM_ALL)

        target_sources(milkyplay
            PRIVATE
                # Sources
                drivers/generic/AudioDriver_RTAUDIO.cpp
                drivers/generic/RtAudio4Impl.cpp

                # Headers
                drivers/generic/AudioDriver_RTAUDIO.h
        )

        target_include_directories(milkyplay
            PRIVATE
                drivers/generic
                ${RTAUDIO_SUBMODULE_DIR}
        )

        target_link_libraries(milkyplay PRIVATE rtaudio)

        # Place targets into IDE subfolder
        set_target_properties(
            rtaudio
            uninstall
            Continuous
            Experimental
            Nightly
            NightlyMemoryCheck
            PROPERTIES FOLDER "Externals/RtAudio"
        )
    else()
        target_compile_definitions(milkyplay PRIVATE -D__SKIPRTAUDIO__)
        message("RtAudio support disabled (RtAudio unavailable)")
    endif()
    target_link_libraries(milkyplay PRIVATE winmm dsound)
elseif(HAIKU)
    target_sources(milkyplay
        PRIVATE
            # Sources
            drivers/haiku/AudioDriver_Haiku.cpp

            # Headers
            drivers/haiku/AudioDriver_Haiku.h
    )
    target_include_directories(milkyplay
        PRIVATE
            drivers/haiku
    )
    target_link_libraries(milkyplay
        PRIVATE
            media
    )
    message(STATUS "Enabled Haiku Audio support")
else()
    target_compile_definitions(milkyplay PRIVATE -DDRIVER_UNIX)

    if(ALSA_FOUND)
        target_sources(milkyplay PRIVATE
            # Sources
            drivers/alsa/AudioDriver_ALSA.cpp

            # Headers
            drivers/alsa/AudioDriver_ALSA.h
        )
        target_compile_definitions(milkyplay PUBLIC -DHAVE_LIBASOUND)
        target_include_directories(milkyplay
            PUBLIC
                ${ALSA_INCLUDE_DIRS}
            PRIVATE
                drivers/alsa
        )
        target_link_libraries(milkyplay PUBLIC ${ALSA_LIBRARIES})
        message(STATUS "Enabled ALSA support")
    endif()

    if(JACK_FOUND)
        target_sources(milkyplay PRIVATE
            # Sources
            drivers/jack/AudioDriver_JACK.cpp

            # Headers
            drivers/jack/AudioDriver_JACK.h
        )
        target_compile_definitions(milkyplay PRIVATE -DHAVE_JACK_JACK_H)
        target_include_directories(milkyplay PRIVATE
            drivers/jack
            ${JACK_INCLUDE_DIRS}
        )
        target_link_libraries(milkyplay PUBLIC ${CMAKE_DL_LIBS})
        message(STATUS "Enabled JACK support")
    endif()

    if(SDL2_FOUND)
        target_sources(milkyplay PRIVATE
            # Sources
            drivers/sdl/AudioDriver_SDL.cpp

            # Headers
            drivers/sdl/AudioDriver_SDL.h
        )
        target_include_directories(milkyplay PRIVATE
            drivers/sdl
            ${SDL2_INCLUDE_DIRS}
        )

        if(TARGET SDL2::SDL2)
            # If the distro built SDL2 with CMake, we can just link to an exported target
            target_link_libraries(milkyplay PUBLIC SDL2::SDL2)
        else()
            # Otherwise we need to do things the old-fashioned way for compatibility
            target_include_directories(milkyplay PUBLIC ${SDL2_INCLUDE_DIRS})
            target_link_libraries(milkyplay PUBLIC ${SDL2_LIBRARIES})
        endif()
        message(STATUS "Enabled SDL2 support")
    endif()
endif()

=== src/tracker/CMakeLists.txt ===
#
#  src/tracker/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

# Create a library for shared functionality
add_library(commandlib STATIC
    # Core services
    ModuleServices.cpp
    SongLengthEstimator.cpp
    TrackerSettingsDatabase.cpp
    
    # WAV functionality
    wav/WAVExporter.cpp
    wav/WAVExportArgs.cpp
    wav/WAVUtils.cpp
    
    # CLI functionality
    ${PROJECT_SOURCE_DIR}/src/cli/CLIParser.cpp
)

target_include_directories(commandlib
    PUBLIC
        # PPUI is needed for BasicTypes.h and other fundamentals
        ${PROJECT_SOURCE_DIR}/src/ppui
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface
        ${PROJECT_SOURCE_DIR}/src/tracker
        ${PROJECT_SOURCE_DIR}/src/cli
        ${CMAKE_CURRENT_SOURCE_DIR}/wav
)

if(WIN32)
    target_include_directories(commandlib PUBLIC
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/win32
    )
else()
    target_include_directories(commandlib PUBLIC
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
    )
endif()

target_link_libraries(commandlib
    PUBLIC
        milkyplay
        ppui
)

add_executable(tracker
    # Sources
    AnimatedFXControl.cpp
    ColorExportImport.cpp
    ColorPaletteContainer.cpp
    fx/Convolver.cpp
    DialogHelp.cpp
    DialogChannelSelector.cpp
    DialogEQ.cpp
    DialogGroupSelection.cpp
    DialogHandlers.cpp
    DialogListBox.cpp
    DialogPanning.cpp
    DialogQuickChooseInstrument.cpp
    DialogResample.cpp
    DialogWithValues.cpp
    DialogZap.cpp
    DialogSliders.cpp
    fx/EQConstants.cpp
    EditorBase.cpp
    EnvelopeContainer.cpp
    EnvelopeEditor.cpp
    EnvelopeEditorControl.cpp
    fx/Equalizer.cpp
    FileExtProvider.cpp
    FileIdentificator.cpp
    GlobalColorConfig.cpp
    InputControlListener.cpp
    LogoBig.cpp
    LogoSmall.cpp
    ModuleEditor.cpp
    PatternEditor.cpp
    PatternEditorClipBoard.cpp
    PatternEditorControl.cpp
    PatternEditorControlEventListener.cpp
    PatternEditorControlKeyboard.cpp
    PatternEditorControlTransposeHandler.cpp
    PatternEditorTools.cpp
    PatternTools.cpp
	Addon.cpp
    PeakLevelControl.cpp
    Piano.cpp
    PianoControl.cpp
    PlayerController.cpp
    PlayerLogic.cpp
    PlayerMaster.cpp
    RecPosProvider.cpp
    RecorderLogic.cpp
    ResamplerHelper.cpp
    VolumeRampHelper.cpp
    SampleEditor.cpp
    SampleEditorControl.cpp
    SampleEditorControlToolHandler.cpp
    SampleEditorResampler.cpp
    SamplePlayer.cpp
    ScopesControl.cpp
    SectionAbout.cpp
    SectionAbstract.cpp
    SectionAdvancedEdit.cpp
    SectionDiskMenu.cpp
    SectionHDRecorder.cpp
    SectionInstruments.cpp
    SectionOptimize.cpp
    SectionQuickOptions.cpp
    SectionSamples.cpp
    SectionSettings.cpp
    SectionSwitcher.cpp
    SectionTranspose.cpp
    SectionUpperLeft.cpp
    SystemMessage.cpp
    fx/Filter.cpp
    Synth.cpp
    Synths.cpp
    SynthFM.cpp
    TabHeaderControl.cpp
    TabManager.cpp
    TabTitleProvider.cpp
    TitlePageManager.cpp
    ToolInvokeHelper.cpp
    Tracker.cpp
    TrackerConfig.cpp
    TrackerInit.cpp
    TrackerKeyboard.cpp
    TrackerSettings.cpp
    TrackerSettingsDatabase.cpp
    TrackerShortCuts.cpp
    TrackerShutDown.cpp
    TrackerStartUp.cpp
    TrackerUpdate.cpp
    Undo.cpp
    VRand.cpp
    Zapper.cpp

    # Headers
    ${PROJECT_BINARY_DIR}/src/tracker/version.h
    AnimatedFXControl.h
    ColorExportImport.h
    ColorPaletteContainer.h
    fx/Convolver.h
    ControlIDs.h
    DialogChannelSelector.h
    DialogEQ.h
    DialogGroupSelection.h
    DialogHandlers.h
    DialogListBox.h
    DialogPanning.h
    DialogQuickChooseInstrument.h
    DialogResample.h
    DialogWithValues.h
    DialogZap.h
    DialogSliders.h
    fx/EQConstants.h
    EditModes.h
    EditorBase.h
    EnvelopeContainer.h
    EnvelopeEditor.h
    EnvelopeEditorControl.h
    fx/Equalizer.h
    FileExtProvider.h
    FileIdentificator.h
    FileTypes.h
    FilterParameters.h
    GlobalColorConfig.h
    InputControlListener.h
    LogoBig.h
    LogoSmall.h
    ModuleEditor.h
    ModuleServices.h
    PatternEditor.h
    PatternEditorControl.h
    PatternEditorTools.h
    PatternTools.h
	Addon.h
    PeakLevelControl.h
    Piano.h
    PianoControl.h
    PlayerController.h
    PlayerCriticalSection.h
    PlayerLogic.h
    PlayerMaster.h
    RecPosProvider.h
    RecorderLogic.h
    ResamplerHelper.h
	VolumeRampHelper.h
    fx/Filter.h
    Synth.h
	  SynthFM.h
    SIPButtons.h
    SampleEditor.h
    SampleEditorControl.h
    SampleEditorControlLastValues.h
    SampleEditorResampler.h
    SamplePlayer.h
    ScopesControl.h
    SectionAbout.h
    SectionAbstract.h
    SectionAdvancedEdit.h
    SectionDiskMenu.h
    SectionHDRecorder.h
    SectionInstruments.h
    SectionOptimize.h
    SectionQuickOptions.h
    SectionSamples.h
    SectionSettings.h
    SectionSwitcher.h
    SectionTranspose.h
    SectionUpperLeft.h
    SongLengthEstimator.h
    SystemMessage.h
    TabHeaderControl.h
    TabManager.h
    TabTitleProvider.h
    TitlePageManager.h
    ToolInvokeHelper.h
    Tracker.h
    TrackerConfig.h
    TrackerSettingsDatabase.h
    Undo.h
    VRand.h
    Zapper.h
)

# Set target name for the executable
if(APPLE OR WIN32)
    # OS X and Windows get a mixed-case binary name
    set_target_properties(tracker PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
else()
    # Linux/other UNIX get a lower-case binary name
    set_target_properties(tracker PROPERTIES OUTPUT_NAME ${PROJECT_NAME_LOWER})
endif()

target_include_directories(tracker
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        # Include the CMake-generated version header from the build directory
        ${PROJECT_BINARY_DIR}/src/tracker
)

target_link_libraries(tracker
    fx
    commandlib
    osinterface
)

if(CMAKE_VERSION GREATER_EQUAL 3.12)
    # CMake >=3.12 can just "link" to object libraries and inherit any objects
    # and include paths
    target_link_libraries(tracker compression)
else()
    # Do things the hard way for older CMake
    target_sources(tracker PRIVATE
        $<TARGET_OBJECTS:compression>
    )
    target_include_directories(tracker PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../compression
    )
endif()

# Add platform-specific sources and include paths
if(APPLE)
    # If generating for Xcode, pass in the Interface Builder source as a
    # resource and Xcode will take care of compiling it properly
    if(${CMAKE_GENERATOR} STREQUAL "Xcode")
        set_source_files_properties(
            cocoa/resources/Application.xib
            PROPERTIES
            MACOSX_PACKAGE_LOCATION
            Resources
        )
    endif()

    # Application and document icons
    file(
        GLOB ICONS ${PROJECT_SOURCE_DIR}/resources/pictures/docicons/osx/*.icns
    )
    list(APPEND ICONS ${PROJECT_SOURCE_DIR}/resources/pictures/carton.icns)

    # Ensure icons are copied to the correct bundle location
    set_source_files_properties(
        ${ICONS} PROPERTIES MACOSX_PACKAGE_LOCATION Resources
    )

    target_sources(tracker PRIVATE
        # Sources
        ${ICONS}
        cocoa/AppDelegate.mm
        cocoa/MTKeyTranslator.mm
        cocoa/MTTrackerView.mm
        cocoa/main.mm
        cocoa/resources/Application.xib

        # Headers
        cocoa/AppDelegate.h
        cocoa/MTKeyTranslator.h
        cocoa/MTTrackerView.h
    )

    target_include_directories(tracker PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/cocoa
    )
elseif(WIN32)
    target_sources(tracker PRIVATE
        # Sources
        win32/PreferencesDialog.cpp
        win32/ThreadTimer.cpp
        win32/Win32_main.cpp
        win32/Win32_resources.rc

        # Headers
        win32/PreferencesDialog.h
        win32/ThreadTimer.h
        win32/Win32_resource.h
    )
elseif(HAIKU)
    target_sources(tracker PRIVATE
        haiku/Haiku_main.cpp
        haiku/Tools.cpp
        haiku/MilkyApplication.cpp
    )

    target_include_directories(tracker
        PRIVATE
        ${PROJECT_SOURCE_DIR}/src/midi/haiku
    )
    target_compile_options(tracker PRIVATE -iquote ${PROJECT_SOURCE_DIR}/src/ppui)


    add_executable(settings
        haiku/MilkySettings/main.cpp
        haiku/MilkySettings/InterfaceSettingsView.cpp
        haiku/MilkySettings/MidiSettingsView.cpp
        haiku/MilkySettings/MilkySettingsApplication.cpp
        haiku/MilkySettings/SettingsWindow.cpp
    )

    set_target_properties(settings PROPERTIES OUTPUT_NAME MilkySettings)
else()
    target_sources(tracker PRIVATE
        # Sources
        sdl/SDL_KeyTranslation.cpp
        sdl/SDL_Main.cpp

        # Headers
        sdl/SDL_KeyTranslation.h
    )
endif()

if(APPLE)
    # Xcode can deal with Interface Builder xibs automatically - if we are not
    # generating for Xcode, then we must manually compile and install any xibs
    if(NOT CMAKE_GENERATOR STREQUAL "Xcode")
        # Locate ibtool
        find_program(IBTOOL ibtool HINTS /usr/bin ${OSX_DEVELOPER_ROOT}/usr/bin)
        if(IBTOOL STREQUAL "IBTOOL-NOTFOUND")
            message(SEND_ERROR "Unable to find ibtool. Is Xcode installed?")
        endif()

        # The Interface Builder xib file to be compiled
        set(
            XIB_FILE
            ${PROJECT_SOURCE_DIR}/src/tracker/cocoa/resources/Application.xib
        )

        # Destination for compiled xib
        set(RESOURCES_DIR $<TARGET_FILE_DIR:tracker>/../Resources)

        # Ensure the destination directory of the compiled xib exists
        add_custom_command(
            TARGET tracker PRE_BUILD COMMAND mkdir -p ${RESOURCES_DIR}
        )

        # Compile the xib file
        add_custom_command(
            TARGET tracker POST_BUILD COMMAND ${IBTOOL} --errors
            --warnings --notices --output-format human-readable-text
            --minimum-deployment-target 10.7 --compile
            ${RESOURCES_DIR}/${MACOSX_BUNDLE_NSMAIN_NIB_FILE}.nib ${XIB_FILE}
            COMMENT "Compiling ${XIB_FILE}"
        )
    endif()

    # Build as an Application Bundle
    set_target_properties(tracker PROPERTIES MACOSX_BUNDLE TRUE)

    # Pass in the Info.plist template, whose variables are defined in the
    # top-level CMakeLists.txt
    set_target_properties(tracker PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST
        ${CMAKE_CURRENT_SOURCE_DIR}/cocoa/resources/Info.plist.in
    )

    # Enable ARC (automatic reference counting) for OS X build
    target_compile_options(tracker PRIVATE -fobjc-arc)

    target_link_libraries(tracker
        midi
        ${CORE_VIDEO_LIBRARY}
        ${OPENGL_LIBRARY}
    )
elseif(WIN32)
    set_target_properties(tracker PROPERTIES WIN32_EXECUTABLE TRUE)

    target_link_libraries(tracker midi)
elseif(HAIKU)
    target_link_libraries(tracker midi be libtracker.so)

    target_link_libraries(settings midi2 be)
else()
    if(ALSA_FOUND AND RTMIDI_FOUND)
        target_compile_definitions(tracker PRIVATE -DHAVE_LIBRTMIDI)
        target_link_libraries(tracker midi)
    endif()
endif()

if(ZLIB_FOUND)
    target_link_libraries(tracker ${ZLIB_LIBRARIES})
endif()

if(UNIX)
    if(ZZIPLIB_FOUND)
        target_link_libraries(tracker ${ZZIPLIB_LIBRARIES})
    endif()

    if(LHASA_FOUND)
        target_link_libraries(tracker ${LHASA_LIBRARIES})
    endif()
endif()

# OS X and Windows install to the root of the prefix, the others install to bin
if(APPLE OR WIN32)
    set(INSTALL_DEST .)
else()

=== src/tools/milkycli/CMakeLists.txt ===
add_executable(milkycli
    milkycli.cpp
)

target_include_directories(milkycli
    PRIVATE
        ${PROJECT_SOURCE_DIR}/src/tracker/wav
)

target_link_libraries(milkycli
    PRIVATE
        commandlib
)

install(TARGETS milkycli
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/control ===
Source: milkytracker
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alex Myczko <tar@debian.org>,
 James Cowgill <jcowgill@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-exec,
 libasound2-dev [linux-any],
 libjack-dev,
 liblhasa-dev,
 librtmidi-dev [linux-any],
 libsdl2-dev,
 libzzip-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/multimedia-team/milkytracker.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/milkytracker
Homepage: https://milkytracker.org/

Package: milkytracker
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 bambootracker,
 cheesecutter,
 freepats,
 goattracker,
 hivelytracker,
 modplug-tools,
 opencubicplayer,
 protracker,
 schism,
Description: music creation tool inspired by Fast Tracker 2
 This is an editor for "tracked" music, i.e. audio samples of instruments
 pitch shifted according to the note data.
 .
 It can load the following module formats: 669, AMS, AMF, DBM, CBA, DIGI,
 DSM, FAR, GMC, GDM, IMF, IT, MOD, MDL, MTM, MXM, OKT, PLM, PSM, PTM, S3M,
 STM, ULT, UNI, and X.
 .
 Export is possible into the formats: XM, MOD, and WAV.
 .
 Supported sample and instrument formats: WAV, IFF/XI, PAT
